#pragma once

using namespace std;
#ifdef WIN32
#include <windows.h>
#include <regex>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <boost/filesystem.hpp>
using namespace stdext;
using namespace std::tr1;
using namespace boost;
typedef			 char		char1024[1024];
typedef unordered_map <string,string> shash;
typedef unordered_map <string, double> dhash;
typedef unordered_map <string, int> ihash;
#else
#include <boost/filesystem.hpp>
#include <boost/regex.hpp>
#include <boost/unordered_map.hpp>
using namespace boost;
typedef			 char		char1024[1024];
typedef unordered_map <string,string> shash;
typedef unordered_map <string,int> ihash;
#endif
#include "armadillo"
using namespace arma;


#define M_PI	3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679
#define Relevance 12
#define ALIGN_4F(n) (((n)+3)&(~3))
#define FILE_HEADER_SIZE 512
#define MIN_PROB 1.0e-5
#define LOGZERO         (-1.0e+10)
#define LOGSMALL        (-0.9e+10)
#define MINLOGEXP		-log(-LOGZERO)			
#define MIN_POST_PROB	1e-5				

enum Model_Task
{
	T_DPM = 0,// DPGMM model
	T_GMM =1, // Driver
};
enum Run_Mode
{
	R_TRAIN = 0,// model
	R_PROJECTION,
	R_SCORE,
	R_CLUSTER,
	R_ALL
};

inline bool checkDir()
{
	//check sys path exist
	filesystem::path superpath("vector");
	filesystem::path scorepath("score");
	filesystem::path outputpath("output");
	if (!filesystem::exists(superpath))
	{
		filesystem::create_directory(superpath);
	}
	if (!filesystem::exists(scorepath))
	{
		filesystem::create_directory(scorepath);
	}
	if (!filesystem::exists(outputpath))
	{
		filesystem::create_directory(outputpath);
	}
	return true;
}
